"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  getTileFactory: true
};
exports.getTileFactory = getTileFactory;

var _line = _interopRequireDefault(require("./line"));

var _point = _interopRequireDefault(require("./point"));

var _polygon = _interopRequireDefault(require("./polygon"));

var _raster = _interopRequireDefault(require("./raster"));

var _rasterData = _interopRequireDefault(require("./rasterData"));

var _interface = require("../interface");

Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _interface[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _interface[key];
    }
  });
});

function getTileFactory(tileType, parser) {
  switch (tileType) {
    case 'PolygonLayer':
      return _polygon.default;

    case 'LineLayer':
      return _line.default;

    case 'PointLayer':
      return _point.default;

    case 'RasterLayer':
      if (parser.dataType === 'arraybuffer') {
        return _rasterData.default;
      } else {
        return _raster.default;
      }

    default:
      console.warn('Current Tile Not Exist!');
      return _raster.default;
  }
}
//# sourceMappingURL=index.js.map